version: "3.7"

services:

  ## DASHBOARD
  dashboard:
    #    tty: true # Enables debugging capabilities when attached to this container.
    image: bitnami/node:10
    #    command: sh -c 'npm run serve:ssr'
    command: sh -c './node_modules/.bin/ng serve --host 0.0.0.0 --port 4200' #--disableHostCheck'
    environment:
      - PORT=4200
#    command: sh -c 'npm run serve:ssr' #--disableHostCheck'
    volumes:
      - ./dashboard:/app

  ## CORE
  core:
    image: bitnami/node:10
    command: sh -c 'npm start'
#    ports:
#      - 3000:3000
#      - 3001:3001
#      - 5000:5000
    env_file:
      - .env
    environment:
      - DATABASE_URL=mongodb://root:password123@mongodb-primary:27017/admin
      - GOPATH=/root/go
    volumes:
      - ./core:/app
      - $HOME/go:/root/go

  ## Envoy Proxy (require for dashboard)
  envoy:
    image: envoyproxy/envoy-alpine:v1.11.1
#    image: envoyproxy/envoy-dev:latest
    command: sh -c '/usr/local/bin/envoy -c /etc/envoy/envoy.yaml'
    ports:
      - 9901:9901
      - 10000:10000
    volumes:
      - ./core/envoy/envoy.yaml:/etc/envoy/envoy.yaml
#      - type: volume
#        source: core/envoy # name of the folder where your envoy configuration is
#        target: /etc/envoy
    depends_on:
      - core
      - dashboard

  ## gRPC Gateway (optional)
  grpc-gateway:
    build:
      context: ./core/grpc-gateway
      dockerfile: Dockerfile
    command: /app/grpc_gateway --backend=core:5000
    #    ports:
    #      - 8080:80
    depends_on:
      - core

  ## MongoDB cluster (https://github.com/bitnami/bitnami-docker-mongodb/blob/master/docker-compose-replicaset.yml)
  mongodb-primary:
    image: 'bitnami/mongodb:4.2'
    ports:
      - 27017:27017
    environment:
      - MONGODB_ADVERTISED_HOSTNAME=mongodb-primary
      - MONGODB_REPLICA_SET_MODE=primary
      - MONGODB_ROOT_PASSWORD=password123
      - MONGODB_REPLICA_SET_KEY=replicasetkey123
    volumes:
      - 'mongodb_master_data:/bitnami'

  mongodb-secondary:
    image: 'bitnami/mongodb:4.2'
    depends_on:
      - mongodb-primary
    environment:
      - MONGODB_ADVERTISED_HOSTNAME=mongodb-secondary
      - MONGODB_REPLICA_SET_MODE=secondary
      - MONGODB_PRIMARY_HOST=mongodb-primary
      - MONGODB_PRIMARY_ROOT_PASSWORD=password123
      - MONGODB_REPLICA_SET_KEY=replicasetkey123

  mongodb-arbiter:
    image: 'bitnami/mongodb:4.2'
    depends_on:
      - mongodb-primary
    environment:
      - MONGODB_ADVERTISED_HOSTNAME=mongodb-arbiter
      - MONGODB_REPLICA_SET_MODE=arbiter
      - MONGODB_PRIMARY_HOST=mongodb-primary
      - MONGODB_PRIMARY_ROOT_PASSWORD=password123
      - MONGODB_REPLICA_SET_KEY=replicasetkey123


  ## Redis cluster (https://github.com/bitnami/bitnami-docker-redis/blob/master/docker-compose-replicaset.yml)
#  redis-master:
#    image: bitnami/redis:5.0
#    environment:
#      - REDIS_REPLICATION_MODE=master
#      - REDIS_PASSWORD=my_master_password
##      - REDIS_DISABLE_COMMANDS=FLUSHDB,FLUSHALL
#    volumes:
#      - redis_data:/bitnami/redis/data
#
#  redis-replica:
#    image: bitnami/redis:5.0
#    depends_on:
#      - redis-master
#    environment:
#      - REDIS_REPLICATION_MODE=slave
#      - REDIS_MASTER_HOST=redis-master
#      - REDIS_MASTER_PORT_NUMBER=6379
#      - REDIS_MASTER_PASSWORD=my_master_password
#      - REDIS_PASSWORD=my_replica_password
##      - REDIS_DISABLE_COMMANDS=FLUSHDB,FLUSHALL

volumes:
  redis_data:
    driver: local
  mongodb_master_data:
    driver: local
